@version 2.3
@warnings
@script generic
snapPos; snapRot;
generic
{
	snapPos = integer(recall("SNAP_POS","1"));
	snapRot = integer(recall("SNAP_ROT","0"));
	posSel = integer(recall("POS_SEL","0"));
	pip = Scene().generalopts[3];
	curtime = Scene().currenttime;
	obj = Scene().getSelect();
	return if(!reqbegin("SnapSets for Layout"));
	if(obj.size() == 1)
		a1 = ctlallitems("Snap To Item");
	else
		a1 = ctlallitems("Snap To Item",obj[1]);
	c1 = ctlcheckbox("Snap Position",snapPos);
	c2 = ctlcheckbox("Snap Rotation",snapRot);
	c3 = ctlcheckbox("Post-Select Parent",posSel);
	return if(!reqpost());
	target = getvalue(a1);
	snapPos = getvalue(c1);
	snapRot = getvalue(c2);
	posSel = getvalue(c3);
  	reqend();
  	store("SNAP_POS",snapPos);
  	store("SNAP_ROT",snapRot);
  	store("POS_SEL",posSel);
	tarpos = target.getWorldPosition(curtime);
	tarrot = target.getWorldRotation(curtime);
  	if(obj.size() == 1)
  	{
	  	if(snapPos)
	  	{
			if(objParent)
			{
				if(!pip)
					CommandInput("ParentInPlace");
				ParentItem(0);
			}

			Position(tarpos.x,tarpos.y,tarpos.z);		
	  	}
	  	if(snapRot)
	  	{
	  		Rotation(tarrot.x,tarrot.y,tarrot.z);
	  	}
		if(!pip)
			CommandInput("ParentInPlace");
		if(objParent)
			ParentItem(objParent.id);
		return;
  	}
	for(i=1;i<=obj.size();i++)		//	number of objects to be transformed
	{
		if(obj[i].id == target.id)
			continue;
		objParent = obj[i].parent;
		objID = obj[i].id;
		SelectItem(objID);
		if(snapPos)
		{
			if(objParent)
			{
				if(!pip)
					CommandInput("ParentInPlace");
				ParentItem(0);
			}
			SelectItem(objID);
			Position(tarpos.x,tarpos.y,tarpos.z);
		}
		if(snapRot)
		{
			tarrot = target.getWorldRotation(curtime);
			Rotation(tarrot.x,tarrot.y,tarrot.z);
		}
		if(!pip)
			CommandInput("ParentInPlace");
		if(objParent)
			ParentItem(objParent.id);
	}
	if(!posSel)
	{
		SelectItem(obj[obj.size()].id);
		for(i=obj.size() - 1;i>=1;i--)
			AddToSelection(obj[i].id);
	}
	else
		SelectItem(obj[1].id);
}
