@version 2.0
@warnings
@script generic

generic
{
	selFlag = 0;
	iterations = recall("ITER",36);
 	scene = getfirstitem(SCENE);
	curtime = scene.currenttime;
	selected = scene.firstSelect();

	for(i=1;selected;i++)
	{
		obj[i] = selected;
		objName[i] = selected.name;
 		selected = scene.nextSelect();
 	}

	if(obj.size() == 1)
	{
		return if(!reqbegin("SnapSets for Layout"));
		a1 = ctlallitems("Snap To Item");
		a2 = ctlinteger("Iterations",iterations);
		return if(!reqpost());

 		target = getvalue(a1);
		iterations = 1 if((iterations = getvalue(a2)) == 0);

	  	reqend();

		store("ITER",interations);

		for(iter=1;iter<=iterations;iter++)
		{
			(x,y,z) = transform(target, obj, 1, curtime);
			Position(x,y,z);
		}
		return;
	}

	for(k=2;k<i;k++)		//	number of objects to be transformed
	{
		target = obj[1];
		objID = obj[k].id;
		SelectItem(objID);
		for(iter=1;iter<=iterations;iter++)
		{
			(x,y,z) = transform(target, obj, k, curtime);
			Position(x,y,z);
		}
	}
	SelectItem(obj[1].id);
	for(k=2;k<i;k++)
		AddToSelection(obj[k].id);
}

transform: target, obj, index, curtime
{
	tarwpos = target.getWorldPosition(curtime);
	loclpos = obj[index].getPosition(curtime);		// source locale posit
	locwpos = obj[index].getWorldPosition(curtime);
	x = (loclpos.x) + (tarwpos.x - locwpos.x);
	y = (loclpos.y) + (tarwpos.y - locwpos.y);
	z = (loclpos.z) + (tarwpos.z - locwpos.z);
	return(x,y,z);
}
